;##################################################################
;
;##################################################################
#include buttons.h

DATA SECTION
ALIGN 4
items	STRUCT
	iStyle	DD	?
	szText	DB	40 DUP (?)
ENDS
button	items	<BS_PUSHBUTTON,"PUSHBUTTON">
		items	<BS_DEFPUSHBUTTON,"DEFPUSHBUTTON">
		items	<BS_CHECKBOX,"CHECKBOX"> 
		items	<BS_AUTOCHECKBOX,"AUTOCHECKBOX">
		items	<BS_RADIOBUTTON,"RADIOBUTTON">
		items	<BS_3STATE,"3STATE">
		items	<BS_AUTO3STATE,"AUTO3STATE">
	    items	<BS_GROUPBOX,"GROUPBOX">
		items	<BS_AUTORADIOBUTTON,"AUTORADIO">
		items	<BS_OWNERDRAW,"OWNERDRAW">
		
ALIGN 4
	ClassName			DB 	"MainWinClass",0
	AppName				DB 	"Goasm buttons",0
;testing
	fmt					DB	"%d",0
	fmt_register		DB	"register holds  %5X and %5X",0
	; fmt_memADDR		DB	"memory adress is %5d ",0
	fmt_handle			DB	"Handle %X - %X - %X - %X - %X - %X - %X - %X - %X - %X ",0
						
	hInstance			DD	?
	CommandLine			DD 	?
	hWnd				DD  ?
    TEST_DATA			DD	?

	 hWndBtn				DD 10D	DUP 0
	
; structures
ALIGN 4
	wc					WNDCLASSEX
	msg					MSG
	
	
CODE SECTION
START:
	INVOKE 	GetModuleHandle, NULL
	MOV 	[hInstance],EAX
	INVOKE 	GetCommandLine
	MOV 	[CommandLine],EAX
	INVOKE 	InitCommonControls
	INVOKE 	WinMain,[hInstance],NULL,[CommandLine],SW_SHOWNORMAL
	INVOKE 	ExitProcess,EAX

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	MOV 	D[wc.cbSize],SIZEOF WNDCLASSEX
	MOV 	D[wc.style], CS_HREDRAW + CS_VREDRAW
	MOV 	[wc.lpfnWndProc], OFFSET WndProc
	MOV 	D[wc.cbClsExtra],NULL
	MOV 	D[wc.cbWndExtra],NULL
	PUSH 	[hInst]
	POP 	[wc.hInstance]
	INVOKE	GetStockObject,WHITE_BRUSH
	MOV 	D[wc.hbrBackground],EAX
	MOV 	D[wc.lpszMenuName],NULL
	MOV 	[wc.lpszClassName],OFFSET ClassName
	
	INVOKE 	LoadIcon,NULL,IDI_APPLICATION
	MOV 	[wc.hIcon],EAX
	MOV 	[wc.hIconSm],EAX
	
	INVOKE 	LoadCursor,NULL,IDC_ARROW
	MOV 	[wc.hCursor],EAX
	
	INVOKE 	RegisterClassEx, ADDR wc
	CMP		EAX,0
	JNE		>
	INVOKE	MessageBoxEx,0,'Error','!!error!!',MB_OK,0
	INVOKE	ExitProcess,0
:	
	INVOKE 	CreateWindowEx,	NULL,\
				ADDR ClassName,\
				ADDR AppName,\
				WS_SYSMENU+WS_VISIBLE,\
				CW_USEDEFAULT,\
				CW_USEDEFAULT,\
				250,\
				900,\
				NULL,\
				NULL,\
				[hInst],\
				0
	MOV 	[hWnd],EAX
	INVOKE 	ShowWindow,[hWnd],[CmdShow]
	INVOKE 	UpdateWindow,[hWnd]

.MESSLOOP
	INVOKE 	GetMessage, ADDR msg,0,0,0
	or 		EAX,EAX
	JZ 		>.QUIT
	INVOKE 	TranslateMessage, ADDR msg
	INVOKE 	DispatchMessage,  ADDR msg
	JMP 	.MESSLOOP
.QUIT
	MOV 	EAX,[msg.wParam]
	RET
ENDF

WndProc FRAME hWnd, uMsg, wParam, lParam
	uses	EBX,EDI,ESI
	LOCAL	szBuffer[50]:D 									; LOCALS
	LOCAL	  Height_Btn:D
	LOCAL	   width_Btn:D 
	LOCAL	       cyBtn:D     
	LOCAL	       cxBtn:D

	CMP 	D[uMsg],WM_CREATE
	JNE		>> .WM_CLOSE
	MOV		d[cxBtn],10								
	MOV		d[cyBtn],50								
	LEA		EDI,button										; get adres of struct
	MOV		d[Height_Btn],40								; height
	MOV		d[width_Btn],153								; width
	XOR		ECX,ECX											; zero counter	
	XOR		EDX,EDX	
	MOV		ESI,ADDR hWndBtn
;button_creation_loop:
L1:
	PUSH	ECX
	PUSH  	0												;
	PUSH    [hInstance]										;hInstance,
	PUSH    0												;HMENU hMenu,	
	PUSH    [hWnd]											;hWndParent,
	PUSH    [Height_Btn]    								;int nHeight,
	PUSH    [width_Btn] 									;int nWidth,
	PUSH  	[cyBtn]      									;int y,
	PUSH    [cxBtn]											;int x,
	LEA		EAX,d[EDI+items.iStyle]							; get addr style
	PUSH    WS_CHILD | WS_VISIBLE| BS_DEFPUSHBUTTON						;DWORD dwStyle,
	LEA		EBX,d[EDI+items.szText]							;Get addr WindowName	
	PUSH    EBX									 			;LPCTSTR lpWindowName,
	PUSH	'BUTTON' 			 							;LPCTSTR lpClassName,
	PUSH	0												;DWORD dwExStyle,
	CALL	CreateWindowEx
 INT 3	
	POP		ECX
	MOV		[ESI+ECX*4],EAX									; save handle
	ADD		d[cyBtn],70										; increase y coord: for next button
	INC		ECX												; increment counter
	ADD		EDI,4											; Point to next item
	CMP		ECX,10 											; how many times we loop												;	
	JNZ		L1												; loop
:	
	JMP		>>.EXIT

.WM_COMMAND
	CMP		d[uMsg],WM_COMMAND
	JNE		>> .WM_CLOSE
	JMP		>>.EXIT
	
.WM_CLOSE
	CMP 	D[uMsg],WM_CLOSE
	JNE 	>.WM_DESTROY
	INVOKE 	DestroyWindow,[hWnd]
	JMP 	>>.EXIT
	
.WM_DESTROY
	CMP 	D[uMsg],WM_DESTROY
	JNE 	>.DEFPROC
	INVOKE 	PostQuitMessage,NULL
	;fall true
.DEFPROC
	INVOKE 	DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
	RET
.EXIT
	XOR 	EAX,EAX
	RET
ENDF

TEST_REG FRAME	hWnd,REG
LOCAL	szLOCALBuffer[50]:d
	INVOKE	wsprintf,ADDR szLOCALBuffer,ADDR fmt_register,[REG],[REG]
	ADD		ESP,(4*4)
	INVOKE	MessageBoxEx,[hWnd],ADDR szLOCALBuffer,'Test Reg Proc with Quit',MB_OK,0
	
	INVOKE	PostQuitMessage,0
	RET
endf

